package org.uoc.winter.listeners;

import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;
import org.apache.log4j.Logger;


public class SessionListener implements HttpSessionListener {
	private int sessionCount = 0;
	private final Logger log = Logger.getRootLogger();
	
    public void sessionCreated(HttpSessionEvent event) {
    	String loghead="(SessionListener) sessionCreated> ";
    	
    	log.info(loghead+"begin");
    	
        synchronized (this) {
            sessionCount++;
        }
 
        log.info(loghead+"id="+ event.getSession().getId());
        log.info(loghead+"count="+ sessionCount);
        
        log.info(loghead+"end");
    }
 
    public void sessionDestroyed(HttpSessionEvent event) {
    	String loghead="(SessionListener) sessionDestroyed> ";
    	
    	log.info(loghead+"begin");
        
    	synchronized (this) {
            sessionCount--;
        }
 
        log.info(loghead+"id="+ event.getSession().getId());
        log.info(loghead+"count="+ sessionCount);
        
        log.info(loghead+"end");
    }
}

