package org.uoc.winter.mvc;

import javax.servlet.ServletContextEvent;
//import javax.servlet.ServletContextListener;
import javax.servlet.ServletContext;

import org.apache.log4j.Logger;

/*
 * Aquesta classe s'encarrega de carregar i processar el fitxer de preferencies especificat
 * a log4jXML. Esta basada en un listener de log4j pero per evitar la necessitat de declarar-ho
 * desde web.xml, ho iniciarem automaticament des del dispatcher servlet quan l'usuari especifiqui
 * un fitxer de configuracio a traves del tag LOG4J
 * Val a dir que JBOSS utilitza la seva propia configuracio de LOG4J
 */
public class ContextFilter 
{
	private final Logger log = Logger.getRootLogger();
	 
    public void contextDestroyed(ServletContextEvent sce)
    {
    	String loghead="contextDestroyed> ";
    	
    	log.info("begin");
    	
    	ServletContext ctx = sce.getServletContext();
        String name = ctx.getServletContextName();
        
        log.info(loghead+"aturat: " + (name == null ? "" : name ));
        
        log.info(loghead+"begin");
    }
 

    public void contextInitialized(ServletContextEvent sce)
    {
    	String loghead="contextInitialized> ";
  
    	log.info(loghead+"begin");
    	
    	ServletContext ctx = sce.getServletContext();
        String name = ctx.getServletContextName();
        
        /* 
         * iniciem els listeners que estiguin configurats
         */
        
        String classlog4j=ctx.getInitParameter("log4jclass");
        String argslog4j=ctx.getInitParameter("log4jargs");
        
        log.info(loghead+"classlog4j="+classlog4j);
        log.info(loghead+"argslog4j="+argslog4j);
        
        // ctx.addListener(classlog4j);
        // ctx.setInitParameter()
        
        log.info(loghead+"iniciat: "+(name == null ? "" : name ));
        
        log.info(loghead+"end");
    }
}