package org.uoc.winter.renderers;

import org.uoc.winter.mvc.Model;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


public class UrlView implements View {
    String path;
    
    public UrlView(String path) { this.path = path; }
    
    public void render(Object model, HttpServletRequest req,
                    HttpServletResponse answ) throws Exception {
       
       loadModel(model, req);
       render (req,answ);
    }

    public void render(HttpServletRequest req,
            HttpServletResponse answ) throws Exception {
    	
        RequestDispatcher rd = req.getRequestDispatcher(path);
        
        if (rd!=null) {          
             rd.forward(req,answ);
        }
        else {          
             throw new Exception("No trobem la vista:" + path);
        }
    }
    
    public void set_path(String val) { path = val; }
    
    protected void loadModel(Object model, HttpServletRequest req) {
       
       if (model instanceof Model) {
          model = ((Model)model).getMap();
       }
       
       if (model instanceof Map<?, ?>) {
            	
          @SuppressWarnings("unchecked")
		  Map<Object, Object> map = (Map<Object, Object>) model;
          
          for (Map.Entry<Object, Object> e: map.entrySet()) {
              Object key = e.getKey();
              Object value = e.getValue();
              
              // passem els atributs del model a la peticio
              req.setAttribute(key.toString(), value);
          }
       }
    }
}