package org.uoc.winter.utils;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import org.apache.log4j.Logger;

/*
 * Classe que representa la configuracio de l'aplicacio i que es configura mitjançant l'atribut
 * ContexteAtribut
 */
public class Configuracio
{
	private final Logger log = Logger.getRootLogger();
	
	private String classeconf="";
	private HashMap<String,String> tags=null;
	
    // groups
	public enum Grups {

        CONTROLLERS,
        VIEWS,
        VALIDATION,
        INTERCEPTOR

    }
	
	// tags
	public enum Tags {

        SCAN,
        ANY,
        JSP,
        HTML,
        NAMES,
        CLASS,
        PRE,
        POST

    }
	
	public Configuracio(String classeconf,String sep) {
		String loghead="Configuracio> ";
		
		log.info(loghead+"begin");
		
		this.classeconf = classeconf;
	    String[] classes = this.classeconf.split(sep); // separador    	
		
	    UtilJavassist util = new UtilJavassist();
		tags = new HashMap<String,String>();
		
		/*
		 * El string classeconf pot indicar una classe o mes d'una, separada
		 * per espais. El framework buscara la primera coincidencia amb el
		 * atribut especificat
		 */
		
		/*
		 * busquem i assignem el valor dels tags
		 */
		
		util.ProcessarConfiguracions(classes,tags);
		
		PrintTags();
		
		log.info(loghead+"end");
	}
	
	public void PrintTags() {
       String loghead="PrintTags> ";
       
       log.info(loghead+"begin");
       
       Set<String> set = tags.keySet();
       for (Iterator<String> it = set.iterator();it.hasNext();) {
           String key = (String)it.next();
           String value = tags.get(key);
           
    	   log.info(loghead+key+"="+value);
       }
       
       log.info(loghead+"end");
	}
	
	/*
	 * retornem si el tag es valid
	 */
	public static boolean AtributValid(String attr) {
	   boolean is_valid=false;
	   
	   // comprovem que stigui ben format (group@tag)
		if (attr.split("@").length!=2) return false;
		
	   if (attr.equals(fullname(Grups.CONTROLLERS,Tags.SCAN))) return true;
	   if (attr.equals(fullname(Grups.VIEWS,Tags.ANY)))        return true;
	   if (attr.equals(fullname(Grups.VIEWS,Tags.JSP)))        return true;
	   if (attr.equals(fullname(Grups.VIEWS,Tags.HTML)))       return true;
	   if (attr.equals(fullname(Grups.VIEWS,Tags.NAMES)))      return true;
	   if (attr.equals(fullname(Grups.VALIDATION,Tags.CLASS))) return true;
	   if (attr.equals(fullname(Grups.INTERCEPTOR,Tags.PRE)))  return true;
	   if (attr.equals(fullname(Grups.INTERCEPTOR,Tags.POST))) return true;
	   
	   return is_valid;
	}
	
	public static Grups grup(String group) { return Grups.valueOf(group.toUpperCase()); }
	public static Tags  tag(String etiqu)  { return Tags.valueOf(etiqu.toUpperCase());  }
	
	private static String fullname(Grups group,Tags tag) { return group.toString().toUpperCase()+"@"+tag.toString().toUpperCase(); }
	
	public HashMap<String,String>  get_tags()                  { return tags;  }
}