package org.uoc.winter.validacions;

import org.uoc.winter.anotacions.ContextAttr;
import org.uoc.winter.utils.Configuracio;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

import org.apache.log4j.Logger;

public class ComprovaContexteAtribut implements ConstraintValidator<ContextAttr,String>
{
	private final Logger log = Logger.getRootLogger();
    private String group;
    private String tag;

    @Override
    public void initialize(ContextAttr attr) {
    	String loghead="initialize> ";
    	
    	log.info(loghead+"begin");
    	
        group = attr.group();
        tag   = attr.tag();
        log.info(loghead+"group="+group);
        log.info(loghead+"tag="+tag);
        
        log.info(loghead+"end");
    }

    @Override
    public boolean isValid(String thisField, ConstraintValidatorContext arg1) {
    	String loghead="isValid> ";
    	boolean is_valid=false;
    	
    	log.info(loghead+"begin");
    	
    	is_valid = Configuracio.AtributValid(thisField);
    	
    	log.info(loghead+"thisField="+thisField+" arg1="+arg1.toString()+" is_valid="+is_valid);
    	
    	log.info(loghead+"end");
    	
    	return is_valid;
    }

}